% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wnba_stats_leaders.R
\name{wnba_homepagewidget}
\alias{wnba_homepagewidget}
\title{\strong{Get WNBA Stats API Homepage Widget Leaders}}
\usage{
wnba_homepagewidget(player_or_team = "Player", ...)
}
\arguments{
\item{player_or_team}{Player or Team}

\item{...}{Additional arguments passed to an underlying function like httr.}
}
\value{
Returns, for current season, a named list of data frames: PTS, REB, AST,
BLK, STL, FG_PCT, FG3M, FG3_PCT, FANTASY_POINTS, TOTAL_PTS,
TOTAL_REB, TOTAL_AST, ALL_TIME_TD3, TD3, GAME_FG3M,
GAME_PTS, GAME_AST, GAME_STL, GAME_BLK, PCT_PTS_3PT,
PCT_PTS_2PT, PCT_PTS_2PT_MR

\strong{PTS}\tabular{ll}{
   col_name \tab types \cr
   title \tab character \cr
   deep_link \tab character \cr
   name \tab character \cr
   timestamp \tab character \cr
   season \tab character \cr
   seasontype \tab character \cr
   permode \tab character \cr
   RANK \tab integer \cr
   PLAYER_ID \tab integer \cr
   PLAYER_NAME \tab character \cr
   TEAM_ID \tab integer \cr
   TEAM_ABBREVIATION \tab character \cr
   PTS \tab numeric \cr
   FIRST_NAME \tab character \cr
   NICKNAME \tab character \cr
   LAST_NAME \tab character \cr
   JERSEY_NUM \tab character \cr
   POSITION \tab character \cr
}


\strong{REB}\tabular{ll}{
   col_name \tab types \cr
   title \tab character \cr
   deep_link \tab character \cr
   name \tab character \cr
   timestamp \tab character \cr
   season \tab character \cr
   seasontype \tab character \cr
   permode \tab character \cr
   RANK \tab integer \cr
   PLAYER_ID \tab integer \cr
   PLAYER_NAME \tab character \cr
   TEAM_ID \tab integer \cr
   TEAM_ABBREVIATION \tab character \cr
   REB \tab numeric \cr
   FIRST_NAME \tab character \cr
   NICKNAME \tab character \cr
   LAST_NAME \tab character \cr
   JERSEY_NUM \tab character \cr
   POSITION \tab character \cr
}


\strong{AST}\tabular{ll}{
   col_name \tab types \cr
   title \tab character \cr
   deep_link \tab character \cr
   name \tab character \cr
   timestamp \tab character \cr
   season \tab character \cr
   seasontype \tab character \cr
   permode \tab character \cr
   RANK \tab integer \cr
   PLAYER_ID \tab integer \cr
   PLAYER_NAME \tab character \cr
   TEAM_ID \tab integer \cr
   TEAM_ABBREVIATION \tab character \cr
   AST \tab numeric \cr
   FIRST_NAME \tab character \cr
   NICKNAME \tab character \cr
   LAST_NAME \tab character \cr
   JERSEY_NUM \tab character \cr
   POSITION \tab character \cr
}


\strong{BLK}\tabular{ll}{
   col_name \tab types \cr
   title \tab character \cr
   deep_link \tab character \cr
   name \tab character \cr
   timestamp \tab character \cr
   season \tab character \cr
   seasontype \tab character \cr
   permode \tab character \cr
   RANK \tab integer \cr
   PLAYER_ID \tab integer \cr
   PLAYER_NAME \tab character \cr
   TEAM_ID \tab integer \cr
   TEAM_ABBREVIATION \tab character \cr
   BLK \tab numeric \cr
   FIRST_NAME \tab character \cr
   NICKNAME \tab character \cr
   LAST_NAME \tab character \cr
   JERSEY_NUM \tab character \cr
   POSITION \tab character \cr
}


\strong{STL}\tabular{ll}{
   col_name \tab types \cr
   title \tab character \cr
   deep_link \tab character \cr
   name \tab character \cr
   timestamp \tab character \cr
   season \tab character \cr
   seasontype \tab character \cr
   permode \tab character \cr
   RANK \tab integer \cr
   PLAYER_ID \tab integer \cr
   PLAYER_NAME \tab character \cr
   TEAM_ID \tab integer \cr
   TEAM_ABBREVIATION \tab character \cr
   STL \tab numeric \cr
   FIRST_NAME \tab character \cr
   NICKNAME \tab character \cr
   LAST_NAME \tab character \cr
   JERSEY_NUM \tab character \cr
   POSITION \tab character \cr
}


\strong{FG_PCT}\tabular{ll}{
   col_name \tab types \cr
   title \tab character \cr
   deep_link \tab character \cr
   name \tab character \cr
   timestamp \tab character \cr
   season \tab character \cr
   seasontype \tab character \cr
   permode \tab character \cr
   RANK \tab integer \cr
   PLAYER_ID \tab integer \cr
   PLAYER_NAME \tab character \cr
   TEAM_ID \tab integer \cr
   TEAM_ABBREVIATION \tab character \cr
   FG_PCT \tab numeric \cr
   FIRST_NAME \tab character \cr
   NICKNAME \tab character \cr
   LAST_NAME \tab character \cr
   JERSEY_NUM \tab character \cr
   POSITION \tab character \cr
}


\strong{FG3M}\tabular{ll}{
   col_name \tab types \cr
   title \tab character \cr
   deep_link \tab character \cr
   name \tab character \cr
   timestamp \tab character \cr
   season \tab character \cr
   seasontype \tab character \cr
   permode \tab character \cr
   RANK \tab integer \cr
   PLAYER_ID \tab integer \cr
   PLAYER_NAME \tab character \cr
   TEAM_ID \tab integer \cr
   TEAM_ABBREVIATION \tab character \cr
   FG3M \tab integer \cr
   FIRST_NAME \tab character \cr
   NICKNAME \tab character \cr
   LAST_NAME \tab character \cr
   JERSEY_NUM \tab character \cr
   POSITION \tab character \cr
}


\strong{FG3_PCT}\tabular{ll}{
   col_name \tab types \cr
   title \tab character \cr
   deep_link \tab character \cr
   name \tab character \cr
   timestamp \tab character \cr
   season \tab character \cr
   seasontype \tab character \cr
   permode \tab character \cr
   RANK \tab integer \cr
   PLAYER_ID \tab integer \cr
   PLAYER_NAME \tab character \cr
   TEAM_ID \tab integer \cr
   TEAM_ABBREVIATION \tab character \cr
   FG3_PCT \tab numeric \cr
   FIRST_NAME \tab character \cr
   NICKNAME \tab character \cr
   LAST_NAME \tab character \cr
   JERSEY_NUM \tab character \cr
   POSITION \tab character \cr
}


\strong{FANTASY_POINTS}\tabular{ll}{
   col_name \tab types \cr
   title \tab character \cr
   deep_link \tab character \cr
   name \tab character \cr
   timestamp \tab character \cr
   season \tab character \cr
   seasontype \tab character \cr
   permode \tab character \cr
   PLAYER_ID \tab integer \cr
   PLAYER_NAME \tab character \cr
   TEAM_ID \tab integer \cr
   TEAM_ABBREVIATION \tab character \cr
   FANTASY_POINTS \tab numeric \cr
   FIRST_NAME \tab character \cr
   NICKNAME \tab character \cr
   LAST_NAME \tab character \cr
   JERSEY_NUM \tab character \cr
   POSITION \tab character \cr
}


\strong{TOTAL_PTS}\tabular{ll}{
   col_name \tab types \cr
   title \tab character \cr
   deep_link \tab character \cr
   name \tab character \cr
   timestamp \tab character \cr
   permode \tab character \cr
   season \tab character \cr
   seasontype \tab character \cr
   PLAYER_ID \tab integer \cr
   PLAYER_NAME \tab character \cr
   PLAYER_NAME_LAST_FIRST \tab character \cr
   NICKNAME \tab character \cr
   TEAM_ID \tab integer \cr
   TEAM_ABBREVIATION \tab character \cr
   TEAM_NAME \tab character \cr
   PTS \tab integer \cr
}


\strong{TOTAL_REB}\tabular{ll}{
   col_name \tab types \cr
   title \tab character \cr
   deep_link \tab character \cr
   name \tab character \cr
   timestamp \tab character \cr
   permode \tab character \cr
   season \tab character \cr
   seasontype \tab character \cr
   PLAYER_ID \tab integer \cr
   PLAYER_NAME \tab character \cr
   PLAYER_NAME_LAST_FIRST \tab character \cr
   NICKNAME \tab character \cr
   TEAM_ID \tab integer \cr
   TEAM_ABBREVIATION \tab character \cr
   TEAM_NAME \tab character \cr
   REB \tab integer \cr
}


\strong{TOTAL_AST}\tabular{ll}{
   col_name \tab types \cr
   title \tab character \cr
   deep_link \tab character \cr
   name \tab character \cr
   timestamp \tab character \cr
   permode \tab character \cr
   season \tab character \cr
   seasontype \tab character \cr
   PLAYER_ID \tab integer \cr
   PLAYER_NAME \tab character \cr
   PLAYER_NAME_LAST_FIRST \tab character \cr
   NICKNAME \tab character \cr
   TEAM_ID \tab integer \cr
   TEAM_ABBREVIATION \tab character \cr
   TEAM_NAME \tab character \cr
   AST \tab integer \cr
}


\strong{ALL_TIME_TD3}\tabular{ll}{
   col_name \tab types \cr
   title \tab character \cr
   deep_link \tab character \cr
   name \tab character \cr
   timestamp \tab character \cr
   permode \tab character \cr
   season \tab character \cr
   seasontype \tab character \cr
   PLAYER_ID \tab integer \cr
   PLAYER_NAME \tab character \cr
   PLAYER_NAME_LAST_FIRST \tab character \cr
   TD3 \tab integer \cr
}


\strong{TD3}\tabular{ll}{
   col_name \tab types \cr
   title \tab character \cr
   deep_link \tab character \cr
   name \tab character \cr
   timestamp \tab character \cr
   permode \tab character \cr
   season \tab character \cr
   seasontype \tab character \cr
   PLAYER_ID \tab integer \cr
   PLAYER_NAME \tab character \cr
   PLAYER_NAME_LAST_FIRST \tab character \cr
   TEAM_ABBREVIATION \tab character \cr
   SEASON_YEAR \tab character \cr
   TD3 \tab integer \cr
}


\strong{GAME_FG3M}\tabular{ll}{
   col_name \tab types \cr
   title \tab character \cr
   deep_link \tab character \cr
   name \tab character \cr
   timestamp \tab character \cr
   permode \tab character \cr
   season \tab character \cr
   seasontype \tab character \cr
   PLAYER_ID \tab integer \cr
   PLAYER_NAME \tab character \cr
   PLAYER_NAME_LAST_FIRST \tab character \cr
   NICKNAME \tab character \cr
   TEAM_ID \tab integer \cr
   TEAM_ABBREVIATION \tab character \cr
   TEAM_NAME \tab character \cr
   FG3M \tab integer \cr
   GAME_ID \tab character \cr
}


\strong{GAME_PTS}\tabular{ll}{
   col_name \tab types \cr
   title \tab character \cr
   deep_link \tab character \cr
   name \tab character \cr
   timestamp \tab character \cr
   permode \tab character \cr
   season \tab character \cr
   seasontype \tab character \cr
   PLAYER_ID \tab integer \cr
   PLAYER_NAME \tab character \cr
   PLAYER_NAME_LAST_FIRST \tab character \cr
   NICKNAME \tab character \cr
   TEAM_ID \tab integer \cr
   TEAM_ABBREVIATION \tab character \cr
   TEAM_NAME \tab character \cr
   PTS \tab integer \cr
   GAME_ID \tab character \cr
}


\strong{GAME_AST}\tabular{ll}{
   col_name \tab types \cr
   title \tab character \cr
   deep_link \tab character \cr
   name \tab character \cr
   timestamp \tab character \cr
   permode \tab character \cr
   season \tab character \cr
   seasontype \tab character \cr
   PLAYER_ID \tab integer \cr
   PLAYER_NAME \tab character \cr
   PLAYER_NAME_LAST_FIRST \tab character \cr
   NICKNAME \tab character \cr
   TEAM_ID \tab integer \cr
   TEAM_ABBREVIATION \tab character \cr
   TEAM_NAME \tab character \cr
   AST \tab integer \cr
   GAME_ID \tab character \cr
}


\strong{GAME_STL}\tabular{ll}{
   col_name \tab types \cr
   title \tab character \cr
   deep_link \tab character \cr
   name \tab character \cr
   timestamp \tab character \cr
   permode \tab character \cr
   season \tab character \cr
   seasontype \tab character \cr
   PLAYER_ID \tab integer \cr
   PLAYER_NAME \tab character \cr
   PLAYER_NAME_LAST_FIRST \tab character \cr
   NICKNAME \tab character \cr
   TEAM_ID \tab integer \cr
   TEAM_ABBREVIATION \tab character \cr
   TEAM_NAME \tab character \cr
   STL \tab integer \cr
   GAME_ID \tab character \cr
}


\strong{GAME_BLK}\tabular{ll}{
   col_name \tab types \cr
   title \tab character \cr
   deep_link \tab character \cr
   name \tab character \cr
   timestamp \tab character \cr
   permode \tab character \cr
   season \tab character \cr
   seasontype \tab character \cr
   PLAYER_ID \tab integer \cr
   PLAYER_NAME \tab character \cr
   PLAYER_NAME_LAST_FIRST \tab character \cr
   NICKNAME \tab character \cr
   TEAM_ID \tab integer \cr
   TEAM_ABBREVIATION \tab character \cr
   TEAM_NAME \tab character \cr
   BLK \tab integer \cr
   GAME_ID \tab character \cr
}


\strong{PCT_PTS_3PT}\tabular{ll}{
   col_name \tab types \cr
   title \tab character \cr
   deep_link \tab character \cr
   name \tab character \cr
   timestamp \tab character \cr
   permode \tab character \cr
   season \tab character \cr
   seasontype \tab character \cr
   PLAYER_ID \tab integer \cr
   PLAYER_NAME \tab character \cr
   PLAYER_NAME_LAST_FIRST \tab character \cr
   NICKNAME \tab character \cr
   TEAM_ID \tab integer \cr
   TEAM_ABBREVIATION \tab character \cr
   TEAM_NAME \tab character \cr
   PCT_PTS_3PT \tab numeric \cr
}


\strong{PCT_PTS_2PT}\tabular{ll}{
   col_name \tab types \cr
   title \tab character \cr
   deep_link \tab character \cr
   name \tab character \cr
   timestamp \tab character \cr
   permode \tab character \cr
   season \tab character \cr
   seasontype \tab character \cr
   PLAYER_ID \tab integer \cr
   PLAYER_NAME \tab character \cr
   PLAYER_NAME_LAST_FIRST \tab character \cr
   NICKNAME \tab character \cr
   TEAM_ID \tab integer \cr
   TEAM_ABBREVIATION \tab character \cr
   TEAM_NAME \tab character \cr
   PCT_PTS_2PT \tab numeric \cr
}


\strong{PCT_PTS_2PT_MR}\tabular{ll}{
   col_name \tab types \cr
   title \tab character \cr
   deep_link \tab character \cr
   name \tab character \cr
   timestamp \tab character \cr
   permode \tab character \cr
   season \tab character \cr
   seasontype \tab character \cr
   PLAYER_ID \tab integer \cr
   PLAYER_NAME \tab character \cr
   PLAYER_NAME_LAST_FIRST \tab character \cr
   NICKNAME \tab character \cr
   TEAM_ID \tab integer \cr
   TEAM_ABBREVIATION \tab character \cr
   TEAM_NAME \tab character \cr
   PCT_PTS_2PT_MR \tab numeric \cr
}
}
\description{
\strong{Get WNBA Stats API Homepage Widget Leaders}

\strong{Get WNBA Stats API Homepage Widget Leaders}
}
\details{
\if{html}{\out{<div class="sourceCode r">}}\preformatted{ wnba_homepagewidget(player_or_team = "Player")
 wnba_homepagewidget(player_or_team = "Team")
}\if{html}{\out{</div>}}
}
\seealso{
Other WNBA Leaders Functions: 
\code{\link{wnba_alltimeleadersgrids}()},
\code{\link{wnba_assistleaders}()},
\code{\link{wnba_assisttracker}()},
\code{\link{wnba_leagueleaders}()}
}
\author{
Saiem Gilani
}
\concept{WNBA Leaders Functions}
